更新到shell脚本版本

This commit is contained in:
neo 2020-12-14 13:06:35 +08:00
parent 984364c2fe
commit 4de87dbab0
8 changed files with 1118 additions and 756 deletions

View File

@ -1,5 +0,0 @@
source "https://rubygems.org"
group :test do
gem "rubocop"
end

View File

@ -1,27 +0,0 @@
GEM
remote: https://rubygems.org/
specs:
ast (2.4.0)
jaro_winkler (1.5.4)
parallel (1.18.0)
parser (2.6.5.0)
ast (~> 2.4.0)
rainbow (3.0.0)
rubocop (0.76.0)
jaro_winkler (~> 1.5.1)
parallel (~> 1.10)
parser (>= 2.6)
rainbow (>= 2.2.2, < 4.0)
ruby-progressbar (~> 1.7)
unicode-display_width (>= 1.4.0, < 1.7)
ruby-progressbar (1.10.1)
unicode-display_width (1.6.0)
PLATFORMS
ruby
DEPENDENCIES
rubocop
BUNDLED WITH
2.0.1

39
LICENSE.txt Executable file → Normal file
View File

@ -1,22 +1,25 @@
Copyright 2009-2016 Homebrew contributors.
BSD 2-Clause License
Copyright (c) 2009-present, Homebrew contributors
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
modification, are permitted provided that the following conditions are met:
1. Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
* Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.
THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
* Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

14
README.md Executable file → Normal file
View File

@ -1,21 +1,19 @@
# Homebrew (un)installer
## Install Homebrew
## Install Homebrew (on macOS or Linux)
```bash
/usr/bin/ruby -e "$(curl -fsSL https://cdn.jsdelivr.net/gh/ineo6/homebrew-install/install)"
/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/install.sh)"
```
More installation information and options at https://docs.brew.sh/Installation.html.
More installation information and options: https://docs.brew.sh/Installation.
### Linux and Windows 10 Subsystem for Linux
Install Homebrew on Linux and Windows 10 Subsystem for Linux: https://docs.brew.sh/Linuxbrew.
If running Linux or WSL, [there are some pre-requisite packages to install](https://docs.brew.sh/Homebrew-on-Linux#requirements).
## Uninstall Homebrew
```bash
/usr/bin/ruby -e "$(curl -fsSL https://cdn.jsdelivr.net/gh/ineo6/homebrew-install/uninstall)"
/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/uninstall.sh)"
```
Download the uninstall script and run `./uninstall --help` to view more uninstall options.
Download the uninstall script and run `/bin/bash uninstall.sh --help` to view more uninstall options.

381
install
View File

@ -1,381 +1,10 @@
#!/usr/bin/ruby
# This script installs to /usr/local only. To install elsewhere (which is
# unsupported) you can untar https://github.com/Homebrew/brew/tarball/master
# anywhere you like.
HOMEBREW_PREFIX = "/usr/local".freeze
HOMEBREW_REPOSITORY = "/usr/local/Homebrew".freeze
HOMEBREW_CACHE = "#{ENV["HOME"]}/Library/Caches/Homebrew".freeze
BREW_REPO = "https://mirrors.ustc.edu.cn/brew.git".freeze
# TODO: bump version when new macOS is released
MACOS_LATEST_SUPPORTED = "10.15".freeze
# TODO: bump version when new macOS is released
MACOS_OLDEST_SUPPORTED = "10.13".freeze
# no analytics during installation
ENV["HOMEBREW_NO_ANALYTICS_THIS_RUN"] = "1"
ENV["HOMEBREW_NO_ANALYTICS_MESSAGE_OUTPUT"] = "1"
# get nicer global variables
require "English"
module Tty
module_function
def blue
bold 34
end
def red
bold 31
end
def reset
escape 0
end
def bold(code = 39)
escape "1;#{code}"
end
def underline
escape "4;39"
end
def escape(code)
"\033[#{code}m" if STDOUT.tty?
end
end
class Array
def shell_s
cp = dup
first = cp.shift
cp.map { |arg| arg.gsub " ", "\\ " }.unshift(first).join(" ")
end
end
def ohai(*args)
puts "#{Tty.blue}==>#{Tty.bold} #{args.shell_s}#{Tty.reset}"
end
def warn(warning)
puts "#{Tty.red}Warning#{Tty.reset}: #{warning.chomp}"
end
def system(*args)
abort "Failed during: #{args.shell_s}" unless Kernel.system(*args)
end
def sudo(*args)
args.unshift("-A") unless ENV["SUDO_ASKPASS"].nil?
ohai "/usr/bin/sudo", *args
system "/usr/bin/sudo", *args
end
def getc
system "/bin/stty raw -echo"
if STDIN.respond_to?(:getbyte)
STDIN.getbyte
else
STDIN.getc
end
ensure
system "/bin/stty -raw echo"
end
def wait_for_user
puts
puts "Press RETURN to continue or any other key to abort"
c = getc
# we test for \r and \n because some stuff does \r instead
abort unless (c == 13) || (c == 10)
end
class Version
include Comparable
attr_reader :parts
def initialize(str)
@parts = str.split(".").map(&:to_i)
end
def <=>(other)
parts <=> self.class.new(other).parts
end
def to_s
parts.join(".")
end
end
def macos_version
@macos_version ||= Version.new(`/usr/bin/sw_vers -productVersion`.chomp[/10\.\d+/])
end
def should_install_command_line_tools?
if macos_version > "10.13"
!File.exist?("/Library/Developer/CommandLineTools/usr/bin/git")
else
!File.exist?("/Library/Developer/CommandLineTools/usr/bin/git") ||
!File.exist?("/usr/include/iconv.h")
end
end
def user_only_chmod?(path)
return false unless File.directory?(path)
mode = File.stat(path).mode & 0777
# u = (mode >> 6) & 07
# g = (mode >> 3) & 07
# o = (mode >> 0) & 07
mode != 0755
end
def chmod?(path)
File.exist?(path) && !(File.readable?(path) && File.writable?(path) && File.executable?(path))
end
def chown?(path)
!File.owned?(path)
end
def chgrp?(path)
!File.grpowned?(path)
end
# USER isn't always set so provide a fall back for the installer and subprocesses.
ENV["USER"] ||= `id -un`.chomp
# Invalidate sudo timestamp before exiting (if it wasn't active before).
Kernel.system "/usr/bin/sudo -n -v 2>/dev/null"
at_exit { Kernel.system "/usr/bin/sudo", "-k" } unless $CHILD_STATUS.success?
# The block form of Dir.chdir fails later if Dir.CWD doesn't exist which I
# guess is fair enough. Also sudo prints a warning message for no good reason
Dir.chdir "/usr"
####################################################################### script
if RUBY_PLATFORM.to_s.downcase.include?("linux")
abort <<-EOABORT
To install Linuxbrew, paste at a terminal prompt:
sh -c "$(curl -fsSL https://raw.githubusercontent.com/Linuxbrew/install/master/install.sh)"
EOABORT
elsif macos_version < "10.7"
abort <<-EOABORT
Your Mac OS X version is too old. See:
#{Tty.underline}https://github.com/mistydemeo/tigerbrew#{Tty.reset}"
EOABORT
elsif macos_version < "10.9"
abort "Your OS X version is too old"
elsif Process.uid.zero?
abort "Don't run this as root!"
elsif !`dsmemberutil checkmembership -U "#{ENV["USER"]}" -G admin`.include?("user is a member")
abort "This script requires the user #{ENV["USER"]} to be an Administrator."
elsif File.directory?(HOMEBREW_PREFIX) && (!File.executable? HOMEBREW_PREFIX)
abort <<-EOABORT
The Homebrew prefix, #{HOMEBREW_PREFIX}, exists but is not searchable. If this is
not intentional, please restore the default permissions and try running the
installer again:
sudo chmod 775 #{HOMEBREW_PREFIX}
EOABORT
# TODO: bump version when new macOS is released
elsif macos_version > MACOS_LATEST_SUPPORTED || macos_version < MACOS_OLDEST_SUPPORTED
who = "We"
if macos_version > MACOS_LATEST_SUPPORTED
what = "pre-release version"
elsif macos_version < MACOS_OLDEST_SUPPORTED
who << " (and Apple)"
what = "old version"
else
return
end
ohai "You are using macOS #{macos_version.parts.join(".")}."
ohai "#{who} do not provide support for this #{what}."
puts <<-EOS
This installation may not succeed.
After installation, you will encounter build failures with some formulae.
Please create pull requests instead of asking for help on Homebrew's GitHub,
Discourse, Twitter or IRC. You are responsible for resolving any issues you
experience while you are running this #{what}.
EOS
end
ohai "This script will install:"
puts "#{HOMEBREW_PREFIX}/bin/brew"
puts "#{HOMEBREW_PREFIX}/share/doc/homebrew"
puts "#{HOMEBREW_PREFIX}/share/man/man1/brew.1"
puts "#{HOMEBREW_PREFIX}/share/zsh/site-functions/_brew"
puts "#{HOMEBREW_PREFIX}/etc/bash_completion.d/brew"
puts HOMEBREW_REPOSITORY.to_s
# Keep relatively in sync with
# https://github.com/Homebrew/brew/blob/master/Library/Homebrew/keg.rb
group_chmods = %w[bin etc include lib sbin share opt var
Frameworks
etc/bash_completion.d lib/pkgconfig
share/aclocal share/doc share/info share/locale share/man
share/man/man1 share/man/man2 share/man/man3 share/man/man4
share/man/man5 share/man/man6 share/man/man7 share/man/man8
var/log var/homebrew var/homebrew/linked
bin/brew]
.map { |d| File.join(HOMEBREW_PREFIX, d) }
.select { |d| chmod?(d) }
# zsh refuses to read from these directories if group writable
zsh_dirs = %w[share/zsh share/zsh/site-functions]
.map { |d| File.join(HOMEBREW_PREFIX, d) }
mkdirs = %w[bin etc include lib sbin share var opt
share/zsh share/zsh/site-functions
var/homebrew var/homebrew/linked
Cellar Caskroom Homebrew Frameworks]
.map { |d| File.join(HOMEBREW_PREFIX, d) }
.reject { |d| File.directory?(d) }
user_chmods = zsh_dirs.select { |d| user_only_chmod?(d) }
chmods = group_chmods + user_chmods
chowns = chmods.select { |d| chown?(d) }
chgrps = chmods.select { |d| chgrp?(d) }
unless group_chmods.empty?
ohai "The following existing directories will be made group writable:"
puts(*group_chmods)
end
unless user_chmods.empty?
ohai "The following existing directories will be made writable by user only:"
puts(*user_chmods)
end
unless chowns.empty?
ohai "The following existing directories will have their owner set to #{Tty.underline}#{ENV["USER"]}#{Tty.reset}:"
puts(*chowns)
end
unless chgrps.empty?
ohai "The following existing directories will have their group set to #{Tty.underline}admin#{Tty.reset}:"
puts(*chgrps)
end
unless mkdirs.empty?
ohai "The following new directories will be created:"
puts(*mkdirs)
end
if should_install_command_line_tools?
ohai "The Xcode Command Line Tools will be installed."
end
wait_for_user if STDIN.tty? && !ENV["CI"]
if File.directory? HOMEBREW_PREFIX
sudo "/bin/chmod", "u+rwx", *chmods unless chmods.empty?
sudo "/bin/chmod", "g+rwx", *group_chmods unless group_chmods.empty?
sudo "/bin/chmod", "755", *user_chmods unless user_chmods.empty?
sudo "/usr/sbin/chown", ENV["USER"], *chowns unless chowns.empty?
sudo "/usr/bin/chgrp", "admin", *chgrps unless chgrps.empty?
else
sudo "/bin/mkdir", "-p", HOMEBREW_PREFIX
sudo "/usr/sbin/chown", "root:wheel", HOMEBREW_PREFIX
end
unless mkdirs.empty?
sudo "/bin/mkdir", "-p", *mkdirs
sudo "/bin/chmod", "g+rwx", *mkdirs
sudo "/bin/chmod", "755", *zsh_dirs
sudo "/usr/sbin/chown", ENV["USER"], *mkdirs
sudo "/usr/bin/chgrp", "admin", *mkdirs
end
sudo "/bin/mkdir", "-p", HOMEBREW_CACHE unless File.directory? HOMEBREW_CACHE
sudo "/bin/chmod", "g+rwx", HOMEBREW_CACHE if chmod? HOMEBREW_CACHE
sudo "/usr/sbin/chown", ENV["USER"], HOMEBREW_CACHE if chown? HOMEBREW_CACHE
sudo "/usr/bin/chgrp", "admin", HOMEBREW_CACHE if chgrp? HOMEBREW_CACHE
system "/usr/bin/touch", "#{HOMEBREW_CACHE}/.cleaned" if File.directory? HOMEBREW_CACHE
if should_install_command_line_tools? && macos_version >= "10.13"
ohai "Searching online for the Command Line Tools"
# This temporary file prompts the 'softwareupdate' utility to list the Command Line Tools
clt_placeholder = "/tmp/.com.apple.dt.CommandLineTools.installondemand.in-progress"
sudo "/usr/bin/touch", clt_placeholder
clt_label_command = "/usr/sbin/softwareupdate -l | " \
"grep -B 1 -E 'Command Line Tools' | " \
"awk -F'*' '/^ *\\*/ {print $2}' | " \
"sed -e 's/^ *Label: //' -e 's/^ *//' | " \
"sort -V | " \
"tail -n1"
clt_label = `#{clt_label_command}`.chomp
unless clt_label.empty?
ohai "Installing #{clt_label}"
sudo "/usr/sbin/softwareupdate", "-i", clt_label
sudo "/bin/rm", "-f", clt_placeholder
sudo "/usr/bin/xcode-select", "--switch", "/Library/Developer/CommandLineTools"
end
end
# Headless install may have failed, so fallback to original 'xcode-select' method
if should_install_command_line_tools? && STDIN.tty?
ohai "Installing the Command Line Tools (expect a GUI popup):"
sudo "/usr/bin/xcode-select", "--install"
puts "Press any key when the installation has completed."
getc
sudo "/usr/bin/xcode-select", "--switch", "/Library/Developer/CommandLineTools"
end
abort <<-EOABORT if `/usr/bin/xcrun clang 2>&1` =~ /license/ && !$CHILD_STATUS.success?
You have not agreed to the Xcode license.
Before running the installer again please agree to the license by opening
Xcode.app or running:
sudo xcodebuild -license
EOABORT
ohai "Downloading and installing Homebrew..."
Dir.chdir HOMEBREW_REPOSITORY do
# we do it in four steps to avoid merge errors when reinstalling
system "git", "init", "-q"
# "git remote add" will fail if the remote is defined in the global config
system "git", "config", "remote.origin.url", BREW_REPO
system "git", "config", "remote.origin.fetch", "+refs/heads/*:refs/remotes/origin/*"
# ensure we don't munge line endings on checkout
system "git", "config", "core.autocrlf", "false"
system "git", "fetch", "origin", "master:refs/remotes/origin/master",
"--tags", "--force"
system "git", "reset", "--hard", "origin/master"
system "ln", "-sf", "#{HOMEBREW_REPOSITORY}/bin/brew", "#{HOMEBREW_PREFIX}/bin/brew"
system "#{HOMEBREW_PREFIX}/bin/brew", "update", "--force"
end
warn "#{HOMEBREW_PREFIX}/bin is not in your PATH." unless ENV["PATH"].split(":").include? "#{HOMEBREW_PREFIX}/bin"
ohai "Installation successful!"
puts
# Use the shell's audible bell.
print "\a"
# Use an extra newline and bold to avoid this being missed.
ohai "Homebrew has enabled anonymous aggregate formulae and cask analytics."
puts <<-EOS
#{Tty.bold}Read the analytics documentation (and how to opt-out) here:
#{Tty.underline}https://docs.brew.sh/Analytics#{Tty.reset}
STDERR.print <<EOS
Warning: The Ruby Homebrew installer is now deprecated and has been rewritten in
Bash. Please migrate to the following command:
/bin/bash -c "$(curl -fsSL https://cdn.jsdelivr.net/gh/ineo6/homebrew-install/install.sh)"
EOS
ohai "Homebrew is run entirely by unpaid volunteers. Please consider donating:"
puts <<-EOS
#{Tty.underline}https://github.com/Homebrew/brew#donations#{Tty.reset}
EOS
Dir.chdir HOMEBREW_REPOSITORY do
system "git", "config", "--local", "--replace-all", "homebrew.analyticsmessage", "true"
system "git", "config", "--local", "--replace-all", "homebrew.caskanalyticsmessage", "true"
end
ohai "Next steps:"
puts "- Run `brew help` to get started"
puts "- Further documentation: "
puts " #{Tty.underline}https://docs.brew.sh#{Tty.reset}"
Kernel.exec "/bin/bash", "-c", '/bin/bash -c "$(curl -fsSL https://cdn.jsdelivr.net/gh/ineo6/homebrew-install/install.sh)"'

684
install.sh Executable file
View File

@ -0,0 +1,684 @@
#!/bin/bash
set -u
# Check if script is run non-interactively (e.g. CI)
# If it is run non-interactively we should not prompt for passwords.
if [[ ! -t 0 || -n "${CI-}" ]]; then
NONINTERACTIVE=1
fi
# First check if the OS is Linux.
if [[ "$(uname)" = "Linux" ]]; then
HOMEBREW_ON_LINUX=1
fi
# On macOS, this script installs to /usr/local only.
# On Linux, it installs to /home/linuxbrew/.linuxbrew if you have sudo access
# and ~/.linuxbrew otherwise.
# To install elsewhere (which is unsupported)
# you can untar https://github.com/Homebrew/brew/tarball/master
# anywhere you like.
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
HOMEBREW_PREFIX="/usr/local"
HOMEBREW_REPOSITORY="/usr/local/Homebrew"
HOMEBREW_CACHE="${HOME}/Library/Caches/Homebrew"
STAT="stat -f"
CHOWN="/usr/sbin/chown"
CHGRP="/usr/bin/chgrp"
GROUP="admin"
TOUCH="/usr/bin/touch"
else
HOMEBREW_PREFIX_DEFAULT="/home/linuxbrew/.linuxbrew"
HOMEBREW_CACHE="${HOME}/.cache/Homebrew"
STAT="stat --printf"
CHOWN="/bin/chown"
CHGRP="/bin/chgrp"
GROUP="$(id -gn)"
TOUCH="/bin/touch"
fi
BREW_REPO="https://mirrors.ustc.edu.cn/brew.git"
# TODO: bump version when new macOS is released or announced
MACOS_NEWEST_UNSUPPORTED="12.0"
# TODO: bump version when new macOS is released
MACOS_OLDEST_SUPPORTED="10.14"
# For Homebrew on Linux
REQUIRED_RUBY_VERSION=2.6 # https://github.com/Homebrew/brew/pull/6556
REQUIRED_GLIBC_VERSION=2.13 # https://docs.brew.sh/Homebrew-on-Linux#requirements
# no analytics during installation
export HOMEBREW_NO_ANALYTICS_THIS_RUN=1
export HOMEBREW_NO_ANALYTICS_MESSAGE_OUTPUT=1
# string formatters
if [[ -t 1 ]]; then
tty_escape() { printf "\033[%sm" "$1"; }
else
tty_escape() { :; }
fi
tty_mkbold() { tty_escape "1;$1"; }
tty_underline="$(tty_escape "4;39")"
tty_blue="$(tty_mkbold 34)"
tty_red="$(tty_mkbold 31)"
tty_bold="$(tty_mkbold 39)"
tty_reset="$(tty_escape 0)"
have_sudo_access() {
local -a args
if [[ -n "${SUDO_ASKPASS-}" ]]; then
args=("-A")
elif [[ -n "${NONINTERACTIVE-}" ]]; then
args=("-n")
fi
if [[ -z "${HAVE_SUDO_ACCESS-}" ]]; then
if [[ -n "${args[*]-}" ]]; then
SUDO="/usr/bin/sudo ${args[*]}"
else
SUDO="/usr/bin/sudo"
fi
if [[ -n "${NONINTERACTIVE-}" ]]; then
${SUDO} -l mkdir &>/dev/null
else
${SUDO} -v && ${SUDO} -l mkdir &>/dev/null
fi
HAVE_SUDO_ACCESS="$?"
fi
if [[ -z "${HOMEBREW_ON_LINUX-}" ]] && [[ "$HAVE_SUDO_ACCESS" -ne 0 ]]; then
abort "Need sudo access on macOS (e.g. the user $USER to be an Administrator)!"
fi
return "$HAVE_SUDO_ACCESS"
}
shell_join() {
local arg
printf "%s" "$1"
shift
for arg in "$@"; do
printf " "
printf "%s" "${arg// /\ }"
done
}
chomp() {
printf "%s" "${1/"$'\n'"/}"
}
ohai() {
printf "${tty_blue}==>${tty_bold} %s${tty_reset}\n" "$(shell_join "$@")"
}
warn() {
printf "${tty_red}Warning${tty_reset}: %s\n" "$(chomp "$1")"
}
abort() {
printf "%s\n" "$1"
exit 1
}
execute() {
if ! "$@"; then
abort "$(printf "Failed during: %s" "$(shell_join "$@")")"
fi
}
execute_sudo() {
local -a args=("$@")
if have_sudo_access; then
if [[ -n "${SUDO_ASKPASS-}" ]]; then
args=("-A" "${args[@]}")
fi
ohai "/usr/bin/sudo" "${args[@]}"
execute "/usr/bin/sudo" "${args[@]}"
else
ohai "${args[@]}"
execute "${args[@]}"
fi
}
getc() {
local save_state
save_state=$(/bin/stty -g)
/bin/stty raw -echo
IFS= read -r -n 1 -d '' "$@"
/bin/stty "$save_state"
}
wait_for_user() {
local c
echo
echo "Press RETURN to continue or any other key to abort"
getc c
# we test for \r and \n because some stuff does \r instead
if ! [[ "$c" == $'\r' || "$c" == $'\n' ]]; then
exit 1
fi
}
major_minor() {
echo "${1%%.*}.$(x="${1#*.}"; echo "${x%%.*}")"
}
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
macos_version="$(major_minor "$(/usr/bin/sw_vers -productVersion)")"
fi
version_gt() {
[[ "${1%.*}" -gt "${2%.*}" ]] || [[ "${1%.*}" -eq "${2%.*}" && "${1#*.}" -gt "${2#*.}" ]]
}
version_ge() {
[[ "${1%.*}" -gt "${2%.*}" ]] || [[ "${1%.*}" -eq "${2%.*}" && "${1#*.}" -ge "${2#*.}" ]]
}
version_lt() {
[[ "${1%.*}" -lt "${2%.*}" ]] || [[ "${1%.*}" -eq "${2%.*}" && "${1#*.}" -lt "${2#*.}" ]]
}
should_install_command_line_tools() {
if [[ -n "${HOMEBREW_ON_LINUX-}" ]]; then
return 1
fi
if version_gt "$macos_version" "10.13"; then
! [[ -e "/Library/Developer/CommandLineTools/usr/bin/git" ]]
else
! [[ -e "/Library/Developer/CommandLineTools/usr/bin/git" ]] ||
! [[ -e "/usr/include/iconv.h" ]]
fi
}
get_permission() {
$STAT "%A" "$1"
}
user_only_chmod() {
[[ -d "$1" ]] && [[ "$(get_permission "$1")" != "755" ]]
}
exists_but_not_writable() {
[[ -e "$1" ]] && ! [[ -r "$1" && -w "$1" && -x "$1" ]]
}
get_owner() {
$STAT "%u" "$1"
}
file_not_owned() {
[[ "$(get_owner "$1")" != "$(id -u)" ]]
}
get_group() {
$STAT "%g" "$1"
}
file_not_grpowned() {
[[ " $(id -G "$USER") " != *" $(get_group "$1") "* ]]
}
# Please sync with 'test_ruby()' in 'Library/Homebrew/utils/ruby.sh' from Homebrew/brew repository.
test_ruby () {
if [[ ! -x $1 ]]
then
return 1
fi
"$1" --enable-frozen-string-literal --disable=gems,did_you_mean,rubyopt -rrubygems -e \
"abort if Gem::Version.new(RUBY_VERSION.to_s.dup).to_s.split('.').first(2) != \
Gem::Version.new('$REQUIRED_RUBY_VERSION').to_s.split('.').first(2)" 2>/dev/null
}
no_usable_ruby() {
local ruby_exec
IFS=$'\n' # Do word splitting on new lines only
for ruby_exec in $(which -a ruby); do
if test_ruby "$ruby_exec"; then
IFS=$' \t\n' # Restore IFS to its default value
return 1
fi
done
IFS=$' \t\n' # Restore IFS to its default value
return 0
}
outdated_glibc() {
local glibc_version
glibc_version=$(ldd --version | head -n1 | grep -o '[0-9.]*$' | grep -o '^[0-9]\+\.[0-9]\+')
version_lt "$glibc_version" "$REQUIRED_GLIBC_VERSION"
}
if [[ -n "${HOMEBREW_ON_LINUX-}" ]] && no_usable_ruby && outdated_glibc
then
abort "$(cat <<-EOFABORT
Homebrew requires Ruby $REQUIRED_RUBY_VERSION which was not found on your system.
Homebrew portable Ruby requires Glibc version $REQUIRED_GLIBC_VERSION or newer,
and your Glibc version is too old.
See ${tty_underline}https://docs.brew.sh/Homebrew-on-Linux#requirements${tty_reset}
Install Ruby $REQUIRED_RUBY_VERSION and add its location to your PATH.
EOFABORT
)"
fi
# USER isn't always set so provide a fall back for the installer and subprocesses.
if [[ -z "${USER-}" ]]; then
USER="$(chomp "$(id -un)")"
export USER
fi
# Invalidate sudo timestamp before exiting (if it wasn't active before).
if ! /usr/bin/sudo -n -v 2>/dev/null; then
trap '/usr/bin/sudo -k' EXIT
fi
# Things can fail later if `pwd` doesn't exist.
# Also sudo prints a warning message for no good reason
cd "/usr" || exit 1
####################################################################### script
if ! command -v git >/dev/null; then
abort "$(cat <<EOABORT
You must install Git before installing Homebrew. See:
${tty_underline}https://docs.brew.sh/Installation${tty_reset}
EOABORT
)"
fi
if ! command -v curl >/dev/null; then
abort "$(cat <<EOABORT
You must install cURL before installing Homebrew. See:
${tty_underline}https://docs.brew.sh/Installation${tty_reset}
EOABORT
)"
fi
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
have_sudo_access
else
if [[ -n "${NONINTERACTIVE-}" ]] ||
[[ -w "$HOMEBREW_PREFIX_DEFAULT" ]] ||
[[ -w "/home/linuxbrew" ]] ||
[[ -w "/home" ]]; then
HOMEBREW_PREFIX="$HOMEBREW_PREFIX_DEFAULT"
else
trap exit SIGINT
if ! /usr/bin/sudo -n -v &>/dev/null; then
ohai "Select the Homebrew installation directory"
echo "- ${tty_bold}Enter your password${tty_reset} to install to ${tty_underline}${HOMEBREW_PREFIX_DEFAULT}${tty_reset} (${tty_bold}recommended${tty_reset})"
echo "- ${tty_bold}Press Control-D${tty_reset} to install to ${tty_underline}$HOME/.linuxbrew${tty_reset}"
echo "- ${tty_bold}Press Control-C${tty_reset} to cancel installation"
fi
if have_sudo_access; then
HOMEBREW_PREFIX="$HOMEBREW_PREFIX_DEFAULT"
else
HOMEBREW_PREFIX="$HOME/.linuxbrew"
fi
trap - SIGINT
fi
HOMEBREW_REPOSITORY="${HOMEBREW_PREFIX}/Homebrew"
fi
if [[ "${EUID:-${UID}}" == "0" ]]; then
abort "Don't run this as root!"
elif [[ -d "$HOMEBREW_PREFIX" && ! -x "$HOMEBREW_PREFIX" ]]; then
abort "$(cat <<EOABORT
The Homebrew prefix, ${HOMEBREW_PREFIX}, exists but is not searchable.
If this is not intentional, please restore the default permissions and
try running the installer again:
sudo chmod 775 ${HOMEBREW_PREFIX}
EOABORT
)"
fi
UNAME_MACHINE="$(uname -m)"
if [[ -z "${HOMEBREW_ON_LINUX-}" ]] && [[ "$UNAME_MACHINE" == "arm64" ]]; then
abort "$(cat <<EOABORT
Homebrew is not (yet) supported on ARM processors!
Rerun the Homebrew installer under Rosetta 2.
If you really know what you are doing and are prepared for a very broken
experience you can use another installation option for installing on ARM:
${tty_underline}https://docs.brew.sh/Installation${tty_reset}
EOABORT
)"
fi
if [[ "$UNAME_MACHINE" != "x86_64" ]]; then
abort "Homebrew is only supported on Intel processors!"
fi
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
if version_lt "$macos_version" "10.7"; then
abort "$(cat <<EOABORT
Your Mac OS X version is too old. See:
${tty_underline}https://github.com/mistydemeo/tigerbrew${tty_reset}
EOABORT
)"
elif version_lt "$macos_version" "10.10"; then
abort "Your OS X version is too old"
elif version_ge "$macos_version" "$MACOS_NEWEST_UNSUPPORTED" || \
version_lt "$macos_version" "$MACOS_OLDEST_SUPPORTED"; then
who="We"
what=""
if version_ge "$macos_version" "$MACOS_NEWEST_UNSUPPORTED"; then
what="pre-release version"
else
who+=" (and Apple)"
what="old version"
fi
ohai "You are using macOS ${macos_version}."
ohai "${who} do not provide support for this ${what}."
echo "$(cat <<EOS
This installation may not succeed.
After installation, you will encounter build failures with some formulae.
Please create pull requests instead of asking for help on Homebrew\'s GitHub,
Discourse, Twitter or IRC. You are responsible for resolving any issues you
experience while you are running this ${what}.
EOS
)
"
fi
fi
ohai "This script will install:"
echo "${HOMEBREW_PREFIX}/bin/brew"
echo "${HOMEBREW_PREFIX}/share/doc/homebrew"
echo "${HOMEBREW_PREFIX}/share/man/man1/brew.1"
echo "${HOMEBREW_PREFIX}/share/zsh/site-functions/_brew"
echo "${HOMEBREW_PREFIX}/etc/bash_completion.d/brew"
echo "${HOMEBREW_REPOSITORY}"
# Keep relatively in sync with
# https://github.com/Homebrew/brew/blob/master/Library/Homebrew/keg.rb
directories=(bin etc include lib sbin share opt var
Frameworks
etc/bash_completion.d lib/pkgconfig
share/aclocal share/doc share/info share/locale share/man
share/man/man1 share/man/man2 share/man/man3 share/man/man4
share/man/man5 share/man/man6 share/man/man7 share/man/man8
var/log var/homebrew var/homebrew/linked
bin/brew)
group_chmods=()
for dir in "${directories[@]}"; do
if exists_but_not_writable "${HOMEBREW_PREFIX}/${dir}"; then
group_chmods+=("${HOMEBREW_PREFIX}/${dir}")
fi
done
# zsh refuses to read from these directories if group writable
directories=(share/zsh share/zsh/site-functions)
zsh_dirs=()
for dir in "${directories[@]}"; do
zsh_dirs+=("${HOMEBREW_PREFIX}/${dir}")
done
directories=(bin etc include lib sbin share var opt
share/zsh share/zsh/site-functions
var/homebrew var/homebrew/linked
Cellar Caskroom Homebrew Frameworks)
mkdirs=()
for dir in "${directories[@]}"; do
if ! [[ -d "${HOMEBREW_PREFIX}/${dir}" ]]; then
mkdirs+=("${HOMEBREW_PREFIX}/${dir}")
fi
done
user_chmods=()
if [[ "${#zsh_dirs[@]}" -gt 0 ]]; then
for dir in "${zsh_dirs[@]}"; do
if user_only_chmod "${dir}"; then
user_chmods+=("${dir}")
fi
done
fi
chmods=()
if [[ "${#group_chmods[@]}" -gt 0 ]]; then
chmods+=("${group_chmods[@]}")
fi
if [[ "${#user_chmods[@]}" -gt 0 ]]; then
chmods+=("${user_chmods[@]}")
fi
chowns=()
chgrps=()
if [[ "${#chmods[@]}" -gt 0 ]]; then
for dir in "${chmods[@]}"; do
if file_not_owned "${dir}"; then
chowns+=("${dir}")
fi
if file_not_grpowned "${dir}"; then
chgrps+=("${dir}")
fi
done
fi
if [[ "${#group_chmods[@]}" -gt 0 ]]; then
ohai "The following existing directories will be made group writable:"
printf "%s\n" "${group_chmods[@]}"
fi
if [[ "${#user_chmods[@]}" -gt 0 ]]; then
ohai "The following existing directories will be made writable by user only:"
printf "%s\n" "${user_chmods[@]}"
fi
if [[ "${#chowns[@]}" -gt 0 ]]; then
ohai "The following existing directories will have their owner set to ${tty_underline}${USER}${tty_reset}:"
printf "%s\n" "${chowns[@]}"
fi
if [[ "${#chgrps[@]}" -gt 0 ]]; then
ohai "The following existing directories will have their group set to ${tty_underline}${GROUP}${tty_reset}:"
printf "%s\n" "${chgrps[@]}"
fi
if [[ "${#mkdirs[@]}" -gt 0 ]]; then
ohai "The following new directories will be created:"
printf "%s\n" "${mkdirs[@]}"
fi
if should_install_command_line_tools; then
ohai "The Xcode Command Line Tools will be installed."
fi
if [[ -z "${NONINTERACTIVE-}" ]]; then
wait_for_user
fi
if [[ -d "${HOMEBREW_PREFIX}" ]]; then
if [[ "${#chmods[@]}" -gt 0 ]]; then
execute_sudo "/bin/chmod" "u+rwx" "${chmods[@]}"
fi
if [[ "${#group_chmods[@]}" -gt 0 ]]; then
execute_sudo "/bin/chmod" "g+rwx" "${group_chmods[@]}"
fi
if [[ "${#user_chmods[@]}" -gt 0 ]]; then
execute_sudo "/bin/chmod" "755" "${user_chmods[@]}"
fi
if [[ "${#chowns[@]}" -gt 0 ]]; then
execute_sudo "$CHOWN" "$USER" "${chowns[@]}"
fi
if [[ "${#chgrps[@]}" -gt 0 ]]; then
execute_sudo "$CHGRP" "$GROUP" "${chgrps[@]}"
fi
else
execute_sudo "/bin/mkdir" "-p" "${HOMEBREW_PREFIX}"
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
execute_sudo "$CHOWN" "root:wheel" "${HOMEBREW_PREFIX}"
else
execute_sudo "$CHOWN" "$USER:$GROUP" "${HOMEBREW_PREFIX}"
fi
fi
if [[ "${#mkdirs[@]}" -gt 0 ]]; then
execute_sudo "/bin/mkdir" "-p" "${mkdirs[@]}"
execute_sudo "/bin/chmod" "g+rwx" "${mkdirs[@]}"
execute_sudo "$CHOWN" "$USER" "${mkdirs[@]}"
execute_sudo "$CHGRP" "$GROUP" "${mkdirs[@]}"
fi
if ! [[ -d "${HOMEBREW_CACHE}" ]]; then
if [[ -z "${HOMEBREW_ON_LINUX-}" ]]; then
execute_sudo "/bin/mkdir" "-p" "${HOMEBREW_CACHE}"
else
execute "/bin/mkdir" "-p" "${HOMEBREW_CACHE}"
fi
fi
if exists_but_not_writable "${HOMEBREW_CACHE}"; then
execute_sudo "/bin/chmod" "g+rwx" "${HOMEBREW_CACHE}"
fi
if file_not_owned "${HOMEBREW_CACHE}"; then
execute_sudo "$CHOWN" "$USER" "${HOMEBREW_CACHE}"
fi
if file_not_grpowned "${HOMEBREW_CACHE}"; then
execute_sudo "$CHGRP" "$GROUP" "${HOMEBREW_CACHE}"
fi
if [[ -d "${HOMEBREW_CACHE}" ]]; then
execute "$TOUCH" "${HOMEBREW_CACHE}/.cleaned"
fi
if should_install_command_line_tools && version_ge "$macos_version" "10.13"; then
ohai "Searching online for the Command Line Tools"
# This temporary file prompts the 'softwareupdate' utility to list the Command Line Tools
clt_placeholder="/tmp/.com.apple.dt.CommandLineTools.installondemand.in-progress"
execute_sudo "$TOUCH" "$clt_placeholder"
clt_label_command="/usr/sbin/softwareupdate -l |
grep -B 1 -E 'Command Line Tools' |
awk -F'*' '/^ *\\*/ {print \$2}' |
sed -e 's/^ *Label: //' -e 's/^ *//' |
sort -V |
tail -n1"
clt_label="$(chomp "$(/bin/bash -c "$clt_label_command")")"
if [[ -n "$clt_label" ]]; then
ohai "Installing $clt_label"
execute_sudo "/usr/sbin/softwareupdate" "-i" "$clt_label"
execute_sudo "/bin/rm" "-f" "$clt_placeholder"
execute_sudo "/usr/bin/xcode-select" "--switch" "/Library/Developer/CommandLineTools"
fi
fi
# Headless install may have failed, so fallback to original 'xcode-select' method
if should_install_command_line_tools && test -t 0; then
ohai "Installing the Command Line Tools (expect a GUI popup):"
execute_sudo "/usr/bin/xcode-select" "--install"
echo "Press any key when the installation has completed."
getc
execute_sudo "/usr/bin/xcode-select" "--switch" "/Library/Developer/CommandLineTools"
fi
if [[ -z "${HOMEBREW_ON_LINUX-}" ]] && ! output="$(/usr/bin/xcrun clang 2>&1)" && [[ "$output" == *"license"* ]]; then
abort "$(cat <<EOABORT
You have not agreed to the Xcode license.
Before running the installer again please agree to the license by opening
Xcode.app or running:
sudo xcodebuild -license
EOABORT
)"
fi
ohai "Downloading and installing Homebrew..."
(
cd "${HOMEBREW_REPOSITORY}" >/dev/null || return
# we do it in four steps to avoid merge errors when reinstalling
execute "git" "init" "-q"
# "git remote add" will fail if the remote is defined in the global config
execute "git" "config" "remote.origin.url" "${BREW_REPO}"
execute "git" "config" "remote.origin.fetch" "+refs/heads/*:refs/remotes/origin/*"
# ensure we don't munge line endings on checkout
execute "git" "config" "core.autocrlf" "false"
execute "git" "fetch" "origin" "--force"
execute "git" "fetch" "origin" "--tags" "--force"
execute "git" "reset" "--hard" "origin/master"
execute "ln" "-sf" "${HOMEBREW_REPOSITORY}/bin/brew" "${HOMEBREW_PREFIX}/bin/brew"
execute "${HOMEBREW_PREFIX}/bin/brew" "update" "--force"
) || exit 1
if [[ ":${PATH}:" != *":${HOMEBREW_PREFIX}/bin:"* ]]; then
warn "${HOMEBREW_PREFIX}/bin is not in your PATH."
fi
ohai "Installation successful!"
echo
# Use the shell's audible bell.
if [[ -t 1 ]]; then
printf "\a"
fi
# Use an extra newline and bold to avoid this being missed.
ohai "Homebrew has enabled anonymous aggregate formulae and cask analytics."
echo "$(cat <<EOS
${tty_bold}Read the analytics documentation (and how to opt-out) here:
${tty_underline}https://docs.brew.sh/Analytics${tty_reset}
No analytics data has been sent yet (or will be during this \`install\` run).
EOS
)
"
ohai "Homebrew is run entirely by unpaid volunteers. Please consider donating:"
echo "$(cat <<EOS
${tty_underline}https://github.com/Homebrew/brew#donations${tty_reset}
EOS
)
"
(
cd "${HOMEBREW_REPOSITORY}" >/dev/null || return
execute "git" "config" "--replace-all" "homebrew.analyticsmessage" "true"
execute "git" "config" "--replace-all" "homebrew.caskanalyticsmessage" "true"
) || exit 1
ohai "Next steps:"
echo "- Run \`brew help\` to get started"
echo "- Further documentation: "
echo " ${tty_underline}https://docs.brew.sh${tty_reset}"
if [[ -n "${HOMEBREW_ON_LINUX-}" ]]; then
case "$SHELL" in
*/bash*)
if [[ -r "$HOME/.bash_profile" ]]; then
shell_profile="$HOME/.bash_profile"
else
shell_profile="$HOME/.profile"
fi
;;
*/zsh*)
shell_profile="$HOME/.zprofile"
;;
*)
shell_profile="$HOME/.profile"
;;
esac
echo "- Install the Homebrew dependencies if you have sudo access:"
if [[ $(command -v apt-get) ]]; then
echo " sudo apt-get install build-essential"
elif [[ $(command -v yum) ]]; then
echo " sudo yum groupinstall 'Development Tools'"
elif [[ $(command -v pacman) ]]; then
echo " sudo pacman -S base-devel"
elif [[ $(command -v apk) ]]; then
echo " sudo apk add build-base"
fi
cat <<EOS
See ${tty_underline}https://docs.brew.sh/linux${tty_reset} for more information
- Add Homebrew to your ${tty_bold}PATH${tty_reset} in ${tty_underline}${shell_profile}${tty_reset}:
echo 'eval \$(${HOMEBREW_PREFIX}/bin/brew shellenv)' >> ${shell_profile}
eval \$(${HOMEBREW_PREFIX}/bin/brew shellenv)
- We recommend that you install GCC:
brew install gcc
EOS
fi

329
uninstall
View File

@ -1,325 +1,10 @@
#!/System/Library/Frameworks/Ruby.framework/Versions/Current/usr/bin/ruby
#!/usr/bin/ruby
require "English"
require "fileutils"
require "optparse"
require "pathname"
STDERR.print <<EOS
Warning: The Ruby Homebrew uninstaller is now deprecated and has been rewritten in
Bash. Please migrate to the following command:
/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/uninstall.sh)"
# Default options
options = {
:force => false,
:quiet => false,
:dry_run => false,
:skip_cache_and_logs => false,
}
EOS
# global status to indicate whether there is anything wrong.
@failed = false
module Tty
module_function
def blue
bold 34
end
def red
bold 31
end
def reset
escape 0
end
def bold(code = 39)
escape "1;#{code}"
end
def escape(code)
"\033[#{code}m" if STDOUT.tty?
end
end
class Array
def shell_s
cp = dup
first = cp.shift
cp.map { |arg| arg.gsub " ", "\\ " }.unshift(first).join(" ")
end
end
class Pathname
def resolved_path
symlink? ? dirname+readlink : self
end
def /(other)
self + other.to_s
end
def pretty_print
if symlink?
puts to_s + " -> " + resolved_path.to_s
elsif directory?
puts to_s + "/"
else
puts to_s
end
end
end
def ohai(*args)
puts "#{Tty.blue}==>#{Tty.bold} #{args.shell_s}#{Tty.reset}"
end
def warn(warning)
puts "#{Tty.red}Warning#{Tty.reset}: #{warning.chomp}"
end
def system(*args)
return if Kernel.system(*args)
warn "Failed during: #{args.shell_s}"
@failed = true
end
####################################################################### script
homebrew_prefix_candidates = []
OptionParser.new do |opts|
opts.banner = "Homebrew Uninstaller\nUsage: ./uninstall [options]"
opts.summary_width = 16
opts.on("-pPATH", "--path=PATH", "Sets Homebrew prefix. Defaults to /usr/local.") do |p|
homebrew_prefix_candidates << Pathname.new(p)
end
opts.on("--skip-cache-and-logs", "Skips removal of HOMEBREW_CACHE and HOMEBREW_LOGS.") do
options[:skip_cache_and_logs] = true
end
opts.on("-f", "--force", "Uninstall without prompting.") { options[:force] = true }
opts.on("-q", "--quiet", "Suppress all output.") { options[:quiet] = true }
opts.on("-d", "--dry-run", "Simulate uninstall but don't remove anything.") do
options[:dry_run] = true
end
opts.on_tail("-h", "--help", "Display this message.") do
puts opts
exit
end
end.parse!
if homebrew_prefix_candidates.empty? # Attempt to locate Homebrew unless `--path` is passed
prefix =
begin
`brew --prefix`
rescue
""
end
homebrew_prefix_candidates << Pathname.new(prefix.strip) unless prefix.empty?
prefix =
begin
begin
`command -v brew`
rescue
`which brew`
end
rescue
""
end
homebrew_prefix_candidates << Pathname.new(prefix.strip).dirname.parent unless prefix.empty?
homebrew_prefix_candidates << Pathname.new("/usr/local") # Homebrew default path
homebrew_prefix_candidates << Pathname.new("#{ENV["HOME"]}/.linuxbrew") # Linuxbrew default path
end
HOMEBREW_PREFIX = homebrew_prefix_candidates.find do |p|
next unless p.directory?
if p.to_s == "/usr/local" && File.exist?("/usr/local/Homebrew/.git")
next true
end
(p/".git").exist? || (p/"bin/brew").executable?
end
abort "Failed to locate Homebrew!" if HOMEBREW_PREFIX.nil?
HOMEBREW_REPOSITORY = if (HOMEBREW_PREFIX/".git").exist?
(HOMEBREW_PREFIX/".git").realpath.dirname
elsif (HOMEBREW_PREFIX/"bin/brew").exist?
(HOMEBREW_PREFIX/"bin/brew").realpath.dirname.parent
end
abort "Failed to locate Homebrew!" if HOMEBREW_REPOSITORY.nil?
HOMEBREW_CELLAR = if (HOMEBREW_PREFIX/"Cellar").exist?
HOMEBREW_PREFIX/"Cellar"
else
HOMEBREW_REPOSITORY/"Cellar"
end
gitignore =
begin
(HOMEBREW_REPOSITORY/".gitignore").read
rescue Errno::ENOENT
`curl -fsSL https://raw.githubusercontent.com/Homebrew/brew/master/.gitignore`
end
abort "Failed to fetch Homebrew .gitignore!" if gitignore.empty?
homebrew_files = gitignore.split("\n")
.select { |line| line.start_with? "!" }
.map { |line| line.chomp("/").gsub(%r{^!?/}, "") }
.reject { |line| %w[bin share share/doc].include?(line) }
.map { |p| HOMEBREW_REPOSITORY/p }
if HOMEBREW_PREFIX.to_s != HOMEBREW_REPOSITORY.to_s
homebrew_files << HOMEBREW_REPOSITORY
homebrew_files += %w[
bin/brew
etc/bash_completion.d/brew
share/doc/homebrew
share/man/man1/brew.1
share/man/man1/brew-cask.1
share/zsh/site-functions/_brew
share/zsh/site-functions/_brew_cask
var/homebrew
].map { |p| HOMEBREW_PREFIX/p }
else
homebrew_files << HOMEBREW_REPOSITORY/".git"
end
homebrew_files << HOMEBREW_CELLAR
homebrew_files << HOMEBREW_PREFIX/"Caskroom"
unless options[:skip_cache_and_logs]
homebrew_files += %W[
#{ENV["HOME"]}/Library/Caches/Homebrew
#{ENV["HOME"]}/Library/Logs/Homebrew
/Library/Caches/Homebrew
#{ENV["HOME"]}/.cache/Homebrew
#{ENV["HOMEBREW_CACHE"]}
#{ENV["HOMEBREW_LOGS"]}
].map { |p| Pathname.new(p) }
end
if RUBY_PLATFORM.to_s.downcase.include? "darwin"
homebrew_files += %W[
/Applications
#{ENV["HOME"]}/Applications
].map { |p| Pathname.new(p) }.select(&:directory?).map do |p|
p.children.select do |app|
app.resolved_path.to_s.start_with? HOMEBREW_CELLAR.to_s
end
end.flatten
end
homebrew_files = homebrew_files.select(&:exist?).sort
unless options[:quiet]
warn "This script #{options[:dry_run] ? "would" : "will"} remove:"
homebrew_files.each(&:pretty_print)
end
if STDIN.tty? && (!options[:force] && !options[:dry_run])
STDERR.print "Are you sure you want to uninstall Homebrew? This will remove your installed packages! [y/N] "
abort unless gets.rstrip =~ /y|yes/i
end
ohai "Removing Homebrew installation..." unless options[:quiet]
paths = %w[Frameworks bin etc include lib opt sbin share var]
.map { |p| HOMEBREW_PREFIX/p }
.select(&:exist?)
.map(&:to_s)
if paths.any?
args = %w[-E] + paths + %w[-regex .*/info/([^.][^/]*\.info|dir)]
if options[:dry_run]
args << "-print"
else
args += %w[-exec /bin/bash -c]
args << "/usr/bin/install-info --delete --quiet {} \"$(dirname {})/dir\""
args << ";"
end
puts "Would delete:" if options[:dry_run]
system "/usr/bin/find", *args
args = paths + %w[-type l -lname */Cellar/*]
if options[:dry_run]
args << "-print"
else
args += %w[-exec unlink {} ;]
end
puts "Would delete:" if options[:dry_run]
system "/usr/bin/find", *args
end
homebrew_files.each do |file|
if options[:dry_run]
puts "Would delete #{file}"
else
begin
FileUtils.rm_rf(file)
rescue => e
warn "Failed to delete #{file}"
puts e.message
@failed = true
end
end
end
# Invalidate sudo timestamp before exiting
at_exit { Kernel.system "/usr/bin/sudo", "-k" }
def sudo(*args)
ohai "/usr/bin/sudo", *args
system "/usr/bin/sudo", *args
end
ohai "Removing empty directories..." unless options[:quiet]
paths = %w[bin etc include lib opt sbin share var
Caskroom Cellar Homebrew Frameworks]
.map { |p| HOMEBREW_PREFIX/p }
.select(&:exist?)
.map(&:to_s)
if paths.any?
args = paths + %w[-name .DS_Store]
if options[:dry_run]
args << "-print"
else
args << "-delete"
end
puts "Would delete:" if options[:dry_run]
sudo "/usr/bin/find", *args
args = paths + %w[-depth -type d -empty]
if options[:dry_run]
args << "-print"
else
args += %w[-exec rmdir {} ;]
end
puts "Would remove directories:" if options[:dry_run]
sudo "/usr/bin/find", *args
end
if options[:dry_run]
exit
else
if HOMEBREW_PREFIX.to_s != "/usr/local" && HOMEBREW_PREFIX.exist?
sudo "rmdir", HOMEBREW_PREFIX.to_s
end
if HOMEBREW_PREFIX.to_s != HOMEBREW_REPOSITORY.to_s && HOMEBREW_REPOSITORY.exist?
sudo "rmdir", HOMEBREW_REPOSITORY.to_s
end
end
unless options[:quiet]
if @failed
warn "Homebrew partially uninstalled (but there were steps that failed)!"
puts "To finish uninstalling rerun this script with `sudo`."
else
ohai "Homebrew uninstalled!"
end
end
residual_files = []
residual_files.concat(HOMEBREW_REPOSITORY.children) if HOMEBREW_REPOSITORY.exist?
residual_files.concat(HOMEBREW_PREFIX.children) if HOMEBREW_PREFIX.exist?
residual_files.uniq!
unless residual_files.empty? || options[:quiet]
puts "The following possible Homebrew files were not deleted:"
residual_files.each(&:pretty_print)
puts "You may wish to remove them yourself.\n"
end
exit 1 if @failed
Kernel.exec "/bin/bash", "-c", '/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/master/uninstall.sh)"' + ' uninstall ' + ARGV.join(" ")

395
uninstall.sh Executable file
View File

@ -0,0 +1,395 @@
#!/bin/bash
set -u
shopt -s extglob
abort() {
printf "%s\n" "$@"
exit 1
}
strip_s() {
local s
for s in "$@"; do
s=${s## }
echo "${s%% }"
done
}
dir_children() {
local p
for p in "$@"; do
[[ -d $p ]] || continue
find "$p" -mindepth 1 -maxdepth 1
done
}
# Set up temp dir
tmpdir=/tmp/uninstall.$$
mkdir -p "$tmpdir" || abort "Unable to create temp dir '$tmpdir'"
trap '
rm -fr "$tmpdir"
# Invalidate sudo timestamp before exiting
/usr/bin/sudo -k
' EXIT
# Default options
opt_force=""
opt_quiet=""
opt_dry_run=""
opt_skip_cache_and_logs=""
# global status to indicate whether there is anything wrong.
failed=false
un=$(uname)
case "$un" in
Linux)
ostype=linux
homebrew_prefix_default=/home/linuxbrew/.linuxbrew
;;
Darwin)
ostype=macos
homebrew_prefix_default=/usr/local
realpath() {
cd "$(dirname "$1")" && echo "$(pwd -P)/$(basename "$1")"
}
;;
*)
abort "Unsupported system type '$un'"
;;
esac
# string formatters
if [[ -t 1 ]]; then
tty_escape() { printf "\033[%sm" "$1"; }
else
tty_escape() { :; }
fi
tty_mkbold() { tty_escape "1;${1:-39}"; }
tty_blue=$(tty_mkbold 34)
tty_red=$(tty_mkbold 31)
tty_bold=$(tty_mkbold 39)
tty_reset=$(tty_escape 0)
have_sudo_access() {
local -a args
if [[ -n "${SUDO_ASKPASS-}" ]]; then
args=("-A")
fi
if [[ -z "${HAVE_SUDO_ACCESS-}" ]]; then
if [[ -n "${args[*]-}" ]]; then
/usr/bin/sudo "${args[@]}" -l mkdir &>/dev/null
else
/usr/bin/sudo -l mkdir &>/dev/null
fi
HAVE_SUDO_ACCESS="$?"
fi
if [[ -z "${HOMEBREW_ON_LINUX-}" ]] && [[ "$HAVE_SUDO_ACCESS" -ne 0 ]]; then
abort "Need sudo access on macOS (e.g. the user $USER to be an Administrator)!"
fi
return "$HAVE_SUDO_ACCESS"
}
shell_join() {
local arg
printf "%s" "$1"
shift
for arg in "$@"; do
printf " "
printf "%s" "${arg// /\ }"
done
}
resolved_pathname() { realpath "$1"; }
pretty_print_pathnames() {
local p
for p in "$@"; do
if [[ -h $p ]]; then
printf '%s -> %s\n' "$p" "$(resolved_pathname "$p")"
elif [[ -d $p ]]; then
echo "$p/"
else
echo "$p"
fi
done
}
chomp() {
printf "%s" "${1/"$'\n'"/}"
}
ohai() {
printf "${tty_blue}==>${tty_bold} %s${tty_reset}\n" "$(shell_join "$@")"
}
warn() {
printf "${tty_red}Warning${tty_reset}: %s\n" "$(chomp "$1")"
}
execute() {
if ! "$@"; then
abort "$(printf "Failed during: %s" "$(shell_join "$@")")"
fi
}
execute_sudo() {
local -a args=("$@")
if [[ -n "${SUDO_ASKPASS-}" ]]; then
args=("-A" "${args[@]}")
fi
if have_sudo_access; then
ohai "/usr/bin/sudo" "${args[@]}"
system "/usr/bin/sudo" "${args[@]}"
else
ohai "${args[@]}"
system "${args[@]}"
fi
}
system() {
if ! "$@"; then
warn "Failed during: $(shell_join "$@")"
failed=true
fi
}
####################################################################### script
homebrew_prefix_candidates=()
usage() {
cat <<EOS
Homebrew Uninstaller
Usage: $0 [options]
-p, --path=PATH Sets Homebrew prefix. Defaults to /usr/local.
--skip-cache-and-logs
Skips removal of HOMEBREW_CACHE and HOMEBREW_LOGS.
-f, --force Uninstall without prompting.
-q, --quiet Suppress all output.
-d, --dry-run Simulate uninstall but don't remove anything.
-h, --help Display this message.
EOS
exit "${1:-0}"
}
while [[ $# -gt 0 ]]; do
case "$1" in
-p*) homebrew_prefix_candidates+=("${1#-p}");;
--path=*) homebrew_prefix_candidates+=("${1#--path=}");;
--skip-cache-and-logs) opt_skip_cache_and_logs=1;;
-f|--force) opt_force=1;;
-q|--quiet) opt_quiet=1;;
-d|--dry-run) opt_dry_run=1;;
-h|--help) usage;;
*) warn "Unrecognized option: '$1'"; usage 1;;
esac
shift
done
if [[ ${#homebrew_prefix_candidates[@]} -eq 0 ]]; then # Attempt to locate Homebrew unless `--path` is passed
prefix=$(brew --prefix)
[[ -n $prefix ]] && homebrew_prefix_candidates+=("$prefix")
prefix=$(command -v brew) || prefix=""
[[ -n $prefix ]] && homebrew_prefix_candidates+=("$(dirname "$(dirname "$(strip_s "$prefix")")")")
homebrew_prefix_candidates+=("$homebrew_prefix_default") # Homebrew default path
homebrew_prefix_candidates+=("$HOME/.linuxbrew") # Linuxbrew default path
fi
HOMEBREW_PREFIX=$(for p in "${homebrew_prefix_candidates[@]}"; do
[[ -d $p ]] || continue
[[ $p == "$homebrew_prefix_default" && -d $p/Homebrew/.git ]] && echo "$p" && break
[[ -d $p/.git || -x $p/bin/brew ]] && echo "$p" && break
done)
[[ -n $HOMEBREW_PREFIX ]] || abort "Failed to locate Homebrew!"
if [[ -d $HOMEBREW_PREFIX/.git ]]; then
HOMEBREW_REPOSITORY=$(dirname "$(realpath "$HOMEBREW_PREFIX/.git")")
elif [[ -x $HOMEBREW_PREFIX/bin/brew ]]; then
HOMEBREW_REPOSITORY=$(dirname "$(dirname "$(realpath "$HOMEBREW_PREFIX/bin/brew")")")
else
abort "Failed to locate Homebrew!"
fi
if [[ -d $HOMEBREW_PREFIX/Cellar ]]; then
HOMEBREW_CELLAR=$HOMEBREW_PREFIX/Cellar
else
HOMEBREW_CELLAR=$HOMEBREW_REPOSITORY/Cellar
fi
if [[ -s $HOMEBREW_REPOSITORY/.gitignore ]]; then
gitignore=$(<"$HOMEBREW_REPOSITORY/.gitignore")
else
gitignore=$(curl -fsSL https://raw.githubusercontent.com/Homebrew/brew/master/.gitignore)
fi
[[ -n $gitignore ]] || abort "Failed to fetch Homebrew .gitignore!"
{
while read -r l; do
[[ $l == \!* ]] || continue
l=${l#\!}
l=${l#/}
[[ $l == @(bin|share|share/doc) ]] && echo "REJECT: $l" >&2 && continue
echo "$HOMEBREW_REPOSITORY/$l"
done <<<"$gitignore"
if [[ $HOMEBREW_PREFIX != "$HOMEBREW_REPOSITORY" ]]; then
echo "$HOMEBREW_REPOSITORY"
for p in \
bin/brew \
etc/bash_completion.d/brew \
share/doc/homebrew \
share/man/man1/brew.1 \
share/man/man1/brew-cask.1 \
share/zsh/site-functions/_brew \
share/zsh/site-functions/_brew_cask \
var/homebrew \
; do
echo "$HOMEBREW_PREFIX/$p"
done
else
echo "$HOMEBREW_REPOSITORY/.git"
fi
echo "$HOMEBREW_CELLAR"
echo "$HOMEBREW_PREFIX/Caskroom"
[[ -n $opt_skip_cache_and_logs ]] || cat <<-EOS
$HOME/Library/Caches/Homebrew
$HOME/Library/Logs/Homebrew
/Library/Caches/Homebrew
$HOME/.cache/Homebrew
${HOMEBREW_CACHE:-}
${HOMEBREW_LOGS:-}
EOS
if [[ $ostype == macos ]]; then
dir_children "/Applications" "$HOME/Applications" | while read -r p2; do
[[ $(resolved_pathname "$p2") == $HOMEBREW_CELLAR/* ]] && echo "$p2"
done
fi
} | while read -r l; do
[[ -e $l ]] && echo "$l"
done | sort -u > "$tmpdir/homebrew_files"
homebrew_files=()
while read -r l; do
homebrew_files+=("$l")
done < "$tmpdir/homebrew_files"
if [[ -z $opt_quiet ]]; then
dry_str=${opt_dry_run:+would}
warn "This script ${dry_str:-will} remove:"
pretty_print_pathnames "${homebrew_files[@]}"
fi
if [[ -t 0 && -z $opt_force && -z $opt_dry_run ]]; then
read -rp "Are you sure you want to uninstall Homebrew? This will remove your installed packages! [y/N] "
[[ $REPLY == [yY]* ]] || abort
fi
[[ -n $opt_quiet ]] || ohai "Removing Homebrew installation..."
paths=()
for p in Frameworks bin etc include lib opt sbin share var; do
p=$HOMEBREW_PREFIX/$p
[[ -e $p ]] && paths+=("$p")
done
if [[ ${#paths[@]} -gt 0 ]]; then
if [[ $ostype == macos ]]; then
args=(-E "${paths[@]}" -regex '.*/info/([^.][^/]*\.info|dir)')
else
args=("${paths[@]}" -regextype posix-extended -regex '.*/info/([^.][^/]*\.info|dir)')
fi
if [[ -n $opt_dry_run ]]; then
args+=(-print)
echo "Would delete:"
else
args+=(-exec /bin/bash -c)
args+=("/usr/bin/install-info --delete --quiet {} \"\$(dirname {})/dir\"")
args+=(';')
fi
system /usr/bin/find "${args[@]}"
args=("${paths[@]}" -type l -lname '*/Cellar/*')
if [[ -n $opt_dry_run ]]; then
args+=(-print)
else
args+=(-exec unlink '{}' ';')
fi
[[ -n $opt_dry_run ]] && echo "Would delete:"
system /usr/bin/find "${args[@]}"
fi
for file in "${homebrew_files[@]}"; do
if [[ -n $opt_dry_run ]]; then
echo "Would delete ${file}"
else
if ! err=$(rm -fr "$file" 2>&1); then
warn "Failed to delete ${file}"
echo "$err"
fi
fi
done
sudo() {
ohai "/usr/bin/sudo" "$@"
system /usr/bin/sudo "$@"
}
[[ -n $opt_quiet ]] || ohai "Removing empty directories..."
paths=()
for p in bin etc include lib opt sbin share var \
Caskroom Cellar Homebrew Frameworks; do
p=$HOMEBREW_PREFIX/$p
[[ -e $p ]] && paths+=("$p")
done
if [[ ${#paths[@]} -gt 0 ]]; then
if [[ $ostype == macos ]]; then
args=("${paths[@]}" -name .DS_Store)
if [[ -n $opt_dry_run ]]; then
args+=(-print)
echo "Would delete:"
else
args+=(-delete)
fi
execute_sudo /usr/bin/find "${args[@]}"
fi
args=("${paths[@]}" -depth -type d -empty)
if [[ -n $opt_dry_run ]]; then
args+=(-print)
echo "Would remove directories:"
else
args+=(-exec rmdir '{}' ';')
fi
execute_sudo /usr/bin/find "${args[@]}"
fi
[[ -n $opt_dry_run ]] && exit
if [[ $HOMEBREW_PREFIX != "$homebrew_prefix_default" && -e $HOMEBREW_PREFIX ]]; then
execute_sudo rmdir "$HOMEBREW_PREFIX"
fi
if [[ $HOMEBREW_PREFIX != "$HOMEBREW_REPOSITORY" && -e $HOMEBREW_REPOSITORY ]]; then
execute_sudo rmdir "$HOMEBREW_REPOSITORY"
fi
if [[ -z $opt_quiet ]]; then
if [[ $failed == true ]]; then
warn "Homebrew partially uninstalled (but there were steps that failed)!"
echo "To finish uninstalling rerun this script with \`sudo\`."
else
ohai "Homebrew uninstalled!"
fi
fi
dir_children "$HOMEBREW_REPOSITORY" "$HOMEBREW_PREFIX" \
| sort -u > "$tmpdir/residual_files"
if [[ -s $tmpdir/residual_files && -z $opt_quiet ]]; then
echo "The following possible Homebrew files were not deleted:"
while read -r f; do
pretty_print_pathnames "$f"
done <"$tmpdir/residual_files"
echo -e "You may wish to remove them yourself.\n"
fi
[[ $failed != true ]]